package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.util.GeniUrn;
import org.skife.jdbi.v2.SQLStatement;
import org.skife.jdbi.v2.sqlobject.Binder;
import org.skife.jdbi.v2.sqlobject.BinderFactory;
import org.skife.jdbi.v2.sqlobject.BindingAnnotation;

import java.lang.annotation.*;

/**
 * BindGeniUrn
 */
@BindingAnnotation(BindGeniUrn.GeniUrnBinderFactory.class)
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.PARAMETER})
public @interface BindGeniUrn {
    String value();

    public static class GeniUrnBinderFactory implements BinderFactory {
        public Binder build(Annotation annotation) {
            return new Binder<BindGeniUrn, GeniUrn>() {
                public void bind(SQLStatement q, BindGeniUrn bind, GeniUrn urn) {
                    q.bind(bind.value(), urn.getValue());
                }
            };
        }
    }
}
